diff --git a/tests/test_api.py b/tests/test_api.py
index 99a7d9dc6..95cb14b25 100644
--- a/tests/test_api.py
+++ b/tests/test_api.py
@@ -1,6 +1,7 @@
 # -*- coding: utf-8 -*-
 
 import pytest
+import io
 import json
 import shutil
 import os
@@ -13,13 +14,11 @@ import datetime
 import time
 import json
 import sys
+import urllib.parse
 import xml.etree.ElementTree as ET
 import zipfile
 
 from django.utils.encoding import force_bytes, force_text
-from django.utils.six import StringIO, BytesIO
-from django.utils.six.moves.urllib import parse as urllib
-from django.utils.six.moves.urllib import parse as urlparse
 
 from quixote import cleanup, get_publisher
 from wcs.qommon.http_request import HTTPRequest
@@ -109,18 +108,18 @@ def admin_user():
 
 def sign_uri(uri, user=None, format='json'):
     timestamp = datetime.datetime.utcnow().isoformat()[:19] + 'Z'
-    scheme, netloc, path, params, query, fragment = urlparse.urlparse(uri)
+    scheme, netloc, path, params, query, fragment = urllib.parse.urlparse(uri)
     if query:
         query += '&'
     if format:
         query += 'format=%s&' % format
     query += 'orig=coucou&algo=sha256&timestamp=' + timestamp
     if user:
-        query += '&email=' + urllib.quote(user.email)
-    query += '&signature=%s' % urllib.quote(
+        query += '&email=' + urllib.parse.quote(user.email)
+    query += '&signature=%s' % urllib.parse.quote(
         base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha256).digest())
     )
-    return urlparse.urlunparse((scheme, netloc, path, params, query, fragment))
+    return urllib.parse.urlunparse((scheme, netloc, path, params, query, fragment))
 
 
 def test_user_page_redirect(pub):
@@ -169,7 +168,7 @@ def test_get_user_from_api_query_string_error_invalid_signature(pub):
 
 
 def test_get_user_from_api_query_string_error_missing_timestamp(pub):
-    signature = urllib.quote(
+    signature = urllib.parse.quote(
         base64.b64encode(hmac.new(b'1234', b'format=json&orig=coucou&algo=sha1', hashlib.sha1).digest())
     )
     output = get_app(pub).get(
@@ -181,7 +180,9 @@ def test_get_user_from_api_query_string_error_missing_timestamp(pub):
 def test_get_user_from_api_query_string_error_missing_email(pub):
     timestamp = datetime.datetime.utcnow().isoformat()[:19] + 'Z'
     query = 'format=json&orig=coucou&algo=sha1&timestamp=' + timestamp
-    signature = urllib.quote(base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest()))
+    signature = urllib.parse.quote(
+        base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest())
+    )
     output = get_app(pub).get('/api/user/?%s&signature=%s' % (query, signature), status=403)
     assert output.json['err_desc'] == 'no user specified'
 
@@ -189,7 +190,9 @@ def test_get_user_from_api_query_string_error_missing_email(pub):
 def test_get_user_from_api_query_string_error_unknown_nameid(pub):
     timestamp = datetime.datetime.utcnow().isoformat()[:19] + 'Z'
     query = 'format=json&orig=coucou&algo=sha1&NameID=xxx&timestamp=' + timestamp
-    signature = urllib.quote(base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest()))
+    signature = urllib.parse.quote(
+        base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest())
+    )
     output = get_app(pub).get('/api/user/?%s&signature=%s' % (query, signature), status=403)
     assert output.json['err_desc'] == 'unknown NameID'
 
@@ -199,7 +202,9 @@ def test_get_user_from_api_query_string_error_missing_email_valid_endpoint(pub):
     # works fine without user.
     timestamp = datetime.datetime.utcnow().isoformat()[:19] + 'Z'
     query = 'format=json&orig=coucou&algo=sha1&timestamp=' + timestamp
-    signature = urllib.quote(base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest()))
+    signature = urllib.parse.quote(
+        base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest())
+    )
     output = get_app(pub).get('/categories?%s&signature=%s' % (query, signature))
     assert output.json == {'data': []}
     output = get_app(pub).get('/json?%s&signature=%s' % (query, signature))
@@ -210,7 +215,9 @@ def test_get_user_from_api_query_string_error_unknown_nameid_valid_endpoint(pub)
     # check the categories and forms endpoints accept an unknown NameID
     timestamp = datetime.datetime.utcnow().isoformat()[:19] + 'Z'
     query = 'format=json&NameID=xxx&orig=coucou&algo=sha1&timestamp=' + timestamp
-    signature = urllib.quote(base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest()))
+    signature = urllib.parse.quote(
+        base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest())
+    )
     output = get_app(pub).get('/categories?%s&signature=%s' % (query, signature))
     assert output.json == {'data': []}
     output = get_app(pub).get('/json?%s&signature=%s' % (query, signature))
@@ -221,11 +228,13 @@ def test_get_user_from_api_query_string_error_success_sha1(pub, local_user):
     timestamp = datetime.datetime.utcnow().isoformat()[:19] + 'Z'
     query = (
         'format=json&orig=coucou&algo=sha1&email='
-        + urllib.quote(local_user.email)
+        + urllib.parse.quote(local_user.email)
         + '&timestamp='
         + timestamp
     )
-    signature = urllib.quote(base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest()))
+    signature = urllib.parse.quote(
+        base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest())
+    )
     output = get_app(pub).get('/api/user/?%s&signature=%s' % (query, signature))
     assert output.json['user_display_name'] == u'Jean Darmette'
 
@@ -234,11 +243,13 @@ def test_get_user_from_api_query_string_error_invalid_signature_algo_mismatch(pu
     timestamp = datetime.datetime.utcnow().isoformat()[:19] + 'Z'
     query = (
         'format=json&orig=coucou&algo=sha256&email='
-        + urllib.quote(local_user.email)
+        + urllib.parse.quote(local_user.email)
         + '&timestamp='
         + timestamp
     )
-    signature = urllib.quote(base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest()))
+    signature = urllib.parse.quote(
+        base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha1).digest())
+    )
     output = get_app(pub).get('/api/user/?%s&signature=%s' % (query, signature), status=403)
     assert output.json['err_desc'] == 'invalid signature'
 
@@ -247,18 +258,21 @@ def test_get_user_from_api_query_string_error_success_sha256(pub, local_user):
     timestamp = datetime.datetime.utcnow().isoformat()[:19] + 'Z'
     query = (
         'format=json&orig=coucou&algo=sha256&email='
-        + urllib.quote(local_user.email)
+        + urllib.parse.quote(local_user.email)
         + '&timestamp='
         + timestamp
     )
-    signature = urllib.quote(base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha256).digest()))
+    signature = urllib.parse.quote(
+        base64.b64encode(hmac.new(b'1234', force_bytes(query), hashlib.sha256).digest())
+    )
     output = get_app(pub).get('/api/user/?%s&signature=%s' % (query, signature))
     assert output.json['user_display_name'] == u'Jean Darmette'
 
 
 def test_sign_url(pub, local_user):
     signed_url = sign_url(
-        'http://example.net/api/user/?format=json&orig=coucou&email=%s' % urllib.quote(local_user.email),
+        'http://example.net/api/user/?format=json&orig=coucou&email=%s'
+        % urllib.parse.quote(local_user.email),
         '1234',
     )
     url = signed_url[len('http://example.net') :]
@@ -269,7 +283,8 @@ def test_sign_url(pub, local_user):
     get_app(pub).get('%s&foo=bar' % url, status=403)
 
     signed_url = sign_url(
-        'http://example.net/api/user/?format=json&orig=coucou&email=%s' % urllib.quote(local_user.email),
+        'http://example.net/api/user/?format=json&orig=coucou&email=%s'
+        % urllib.parse.quote(local_user.email),
         '12345',
     )
     url = signed_url[len('http://example.net') :]
@@ -283,7 +298,8 @@ def test_get_user(pub, local_user):
     local_user.roles = [role.id]
     local_user.store()
     signed_url = sign_url(
-        'http://example.net/api/user/?format=json&orig=coucou&email=%s' % urllib.quote(local_user.email),
+        'http://example.net/api/user/?format=json&orig=coucou&email=%s'
+        % urllib.parse.quote(local_user.email),
         '1234',
     )
     url = signed_url[len('http://example.net') :]
@@ -308,7 +324,7 @@ def test_api_access_from_xml_storable_object(pub, local_user, admin_user):
     local_user.store()
     signed_url = sign_url(
         'http://example.net/api/user/?format=json&orig=UNKNOWN_ACCESS&email=%s'
-        % (urllib.quote(local_user.email)),
+        % (urllib.parse.quote(local_user.email)),
         '5678',
     )
     url = signed_url[len('http://example.net') :]
@@ -316,7 +332,8 @@ def test_api_access_from_xml_storable_object(pub, local_user, admin_user):
     assert output.json['err_desc'] == 'invalid orig'
 
     signed_url = sign_url(
-        'http://example.net/api/user/?format=json&orig=salut&email=%s' % (urllib.quote(local_user.email)),
+        'http://example.net/api/user/?format=json&orig=salut&email=%s'
+        % (urllib.parse.quote(local_user.email)),
         '5678',
     )
     url = signed_url[len('http://example.net') :]
@@ -337,7 +354,7 @@ def test_is_url_signed_check_nonce(pub, local_user, freezer):
     pub.clean_nonces(now=0)
     nonce_dir = os.path.join(pub.app_dir, 'nonces')
     assert not os.path.exists(nonce_dir) or not os.listdir(nonce_dir)
-    signed_url = sign_url('?format=json&orig=%s&email=%s' % (ORIG, urllib.quote(local_user.email)), KEY)
+    signed_url = sign_url('?format=json&orig=%s&email=%s' % (ORIG, urllib.parse.quote(local_user.email)), KEY)
     req = HTTPRequest(
         None, {'SCRIPT_NAME': '/', 'SERVER_NAME': 'example.net', 'QUERY_STRING': signed_url[1:]}
     )
@@ -367,7 +384,8 @@ def test_is_url_signed_check_nonce(pub, local_user, freezer):
 
 def test_get_user_compat_endpoint(pub, local_user):
     signed_url = sign_url(
-        'http://example.net/user?format=json&orig=coucou&email=%s' % urllib.quote(local_user.email), '1234'
+        'http://example.net/user?format=json&orig=coucou&email=%s' % urllib.parse.quote(local_user.email),
+        '1234',
     )
     url = signed_url[len('http://example.net') :]
     output = get_app(pub).get(url)
@@ -659,7 +677,7 @@ def test_formdef_schema(pub):
     formdef.store()
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: StringIO(
+        urlopen.side_effect = lambda *args: io.StringIO(
             '''\
 {"data": [{"id": 0, "text": "zéro", "foo": "bar"}, \
 {"id": 1, "text": "uné", "foo": "bar1"}, \
@@ -772,7 +790,7 @@ def test_formdef_submit(pub, local_user):
     def url():
         signed_url = sign_url(
             'http://example.net/api/formdefs/test/submit'
-            + '?format=json&orig=coucou&email=%s' % urllib.quote(local_user.email),
+            + '?format=json&orig=coucou&email=%s' % urllib.parse.quote(local_user.email),
             '1234',
         )
         return signed_url[len('http://example.net') :]
@@ -867,7 +885,7 @@ def test_formdef_submit_only_one(pub, local_user):
     def url():
         signed_url = sign_url(
             'http://example.net/api/formdefs/test/submit'
-            + '?format=json&orig=coucou&email=%s' % urllib.quote(local_user.email),
+            + '?format=json&orig=coucou&email=%s' % urllib.parse.quote(local_user.email),
             '1234',
         )
         return signed_url[len('http://example.net') :]
@@ -928,7 +946,7 @@ def test_formdef_submit_with_varname(pub, local_user):
 
     signed_url = sign_url(
         'http://example.net/api/formdefs/test/submit'
-        + '?format=json&orig=coucou&email=%s' % urllib.quote(local_user.email),
+        + '?format=json&orig=coucou&email=%s' % urllib.parse.quote(local_user.email),
         '1234',
     )
     url = signed_url[len('http://example.net') :]
@@ -2349,7 +2367,7 @@ def test_api_ods_formdata(pub, local_user):
 
     resp = get_app(pub).get(sign_uri('/api/forms/test/ods', user=local_user))
     assert resp.content_type == 'application/vnd.oasis.opendocument.spreadsheet'
-    zipf = zipfile.ZipFile(BytesIO(resp.body))
+    zipf = zipfile.ZipFile(io.BytesIO(resp.body))
     ods_sheet = ET.parse(zipf.open('content.xml'))
     assert len(ods_sheet.findall('.//{%s}table-row' % ods.NS['table'])) == 311
 
@@ -2539,7 +2557,7 @@ def test_api_ods_formdata_custom_view(pub, local_user):
 
     # check it now gets the data
     resp = get_app(pub).get(sign_uri('/api/forms/test/ods', user=local_user))
-    zipf = zipfile.ZipFile(BytesIO(resp.body))
+    zipf = zipfile.ZipFile(io.BytesIO(resp.body))
     ods_sheet = ET.parse(zipf.open('content.xml'))
     assert len(ods_sheet.findall('.//{%s}table-row' % ods.NS['table'])) == 11
 
@@ -2553,7 +2571,7 @@ def test_api_ods_formdata_custom_view(pub, local_user):
     custom_view.store()
 
     resp = get_app(pub).get(sign_uri('/api/forms/test/ods/custom-view', user=local_user))
-    zipf = zipfile.ZipFile(BytesIO(resp.body))
+    zipf = zipfile.ZipFile(io.BytesIO(resp.body))
     ods_sheet = ET.parse(zipf.open('content.xml'))
     assert len(ods_sheet.findall('.//{%s}table-row' % ods.NS['table'])) == 21
 
@@ -3525,7 +3543,7 @@ def test_get_secret_and_orig(no_request_pub):
 
 def test_reverse_geocoding(pub):
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: StringIO(json.dumps({'address': 'xxx'}))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps({'address': 'xxx'}))
         get_app(pub).get('/api/reverse-geocoding', status=400)
         resp = get_app(pub).get('/api/reverse-geocoding?lat=0&lon=0')
         assert resp.content_type == 'application/json'
@@ -3599,13 +3617,13 @@ def test_formdef_submit_structured(pub, local_user):
     def url():
         signed_url = sign_url(
             'http://example.net/api/formdefs/test/submit'
-            '?format=json&orig=coucou&email=%s' % urllib.quote(local_user.email),
+            '?format=json&orig=coucou&email=%s' % urllib.parse.quote(local_user.email),
             '1234',
         )
         return signed_url[len('http://example.net') :]
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: StringIO(
+        urlopen.side_effect = lambda *args: io.StringIO(
             '''\
 {"data": [{"id": 0, "text": "zéro", "foo": "bar"}, \
 {"id": 1, "text": "uné", "foo": "bar1"}, \
@@ -3643,7 +3661,7 @@ def test_formdef_submit_structured(pub, local_user):
 
 def test_geocoding(pub):
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: StringIO(json.dumps([{'lat': 0, 'lon': 0}]))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps([{'lat': 0, 'lon': 0}]))
         get_app(pub).get('/api/geocoding', status=400)
         resp = get_app(pub).get('/api/geocoding?q=test')
         assert resp.content_type == 'application/json'
diff --git a/tests/test_carddef.py b/tests/test_carddef.py
index f44579851..d9524ab46 100644
--- a/tests/test_carddef.py
+++ b/tests/test_carddef.py
@@ -1,8 +1,7 @@
+import io
 import pytest
 import xml.etree.ElementTree as ET
 
-from django.utils.six import BytesIO
-
 from wcs.qommon.http_request import HTTPRequest
 from wcs.qommon.misc import indent_xml as indent
 from wcs.qommon.template import Template
@@ -141,7 +140,7 @@ def test_xml_export_import(pub):
     carddef.data_class().wipe()
     pub.custom_view_class.wipe()
 
-    carddef2 = CardDef.import_from_xml(BytesIO(ET.tostring(carddef_xml)))
+    carddef2 = CardDef.import_from_xml(io.BytesIO(ET.tostring(carddef_xml)))
     assert carddef2.name == 'foo'
     assert carddef2.fields[1].data_source == {'type': 'carddef:foo'}
     assert carddef2._custom_views
diff --git a/tests/test_categories.py b/tests/test_categories.py
index d76e27e5e..ed7d3d890 100644
--- a/tests/test_categories.py
+++ b/tests/test_categories.py
@@ -1,10 +1,10 @@
+import io
 import os
 import pickle
 import shutil
 
 import pytest
 
-from django.utils.six import BytesIO
 from quixote import cleanup
 
 from wcs.categories import Category, CardDefCategory
@@ -108,7 +108,7 @@ def test_xml_import(category_class):
     test.store()
     test = category_class.get(1)
 
-    fd = BytesIO(test.export_to_xml_string(include_id=True))
+    fd = io.BytesIO(test.export_to_xml_string(include_id=True))
     test2 = category_class.import_from_xml(fd, include_id=True)
     assert test.id == test2.id
     assert test.name == test2.name
diff --git a/tests/test_datasource.py b/tests/test_datasource.py
index ff95de889..bd7bc7737 100644
--- a/tests/test_datasource.py
+++ b/tests/test_datasource.py
@@ -1,13 +1,13 @@
 # -*- coding: utf-8 -*-
 
 import codecs
+import io
 import pytest
 import os
 import json
 import shutil
 
-from django.utils.six import StringIO
-from django.utils.six.moves.urllib import parse as urlparse
+import urllib.parse
 
 from quixote import cleanup
 from wcs.qommon.http_request import HTTPRequest
@@ -889,7 +889,7 @@ def test_data_source_unicode():
     data_source2 = NamedDataSource.select()[0]
     assert data_source2.data_source == data_source.data_source
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: StringIO(
+        urlopen.side_effect = lambda *args: io.StringIO(
             '{"data": [{"id": 0, "text": "zéro"}, {"id": 1, "text": "uné"}, {"id": 2, "text": "deux"}]}'
         )
         assert data_sources.get_items({'type': 'foobar'}) == [
@@ -906,12 +906,12 @@ def test_data_source_signed(no_request_pub):
     data_source.store()
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: StringIO('{"data": [{"id": 0, "text": "zero"}]}')
+        urlopen.side_effect = lambda *args: io.StringIO('{"data": [{"id": 0, "text": "zero"}]}')
         assert len(data_sources.get_items({'type': 'foobar'})) == 1
         signed_url = urlopen.call_args[0][0]
     assert signed_url.startswith('https://api.example.com/json?')
-    parsed = urlparse.urlparse(signed_url)
-    querystring = urlparse.parse_qs(parsed.query)
+    parsed = urllib.parse.urlparse(signed_url)
+    querystring = urllib.parse.parse_qs(parsed.query)
     # stupid simple (but sufficient) signature test:
     assert querystring['algo'] == ['sha256']
     assert querystring['orig'] == ['example.net']
@@ -922,12 +922,12 @@ def test_data_source_signed(no_request_pub):
     data_source.data_source = {'type': 'json', 'value': "https://api.example.com/json?foo=bar"}
     data_source.store()
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: StringIO('{"data": [{"id": 0, "text": "zero"}]}')
+        urlopen.side_effect = lambda *args: io.StringIO('{"data": [{"id": 0, "text": "zero"}]}')
         assert len(data_sources.get_items({'type': 'foobar'})) == 1
         signed_url = urlopen.call_args[0][0]
     assert signed_url.startswith('https://api.example.com/json?')
-    parsed = urlparse.urlparse(signed_url)
-    querystring = urlparse.parse_qs(parsed.query)
+    parsed = urllib.parse.urlparse(signed_url)
+    querystring = urllib.parse.parse_qs(parsed.query)
     assert querystring['algo'] == ['sha256']
     assert querystring['orig'] == ['example.net']
     assert querystring['nonce'][0]
@@ -938,7 +938,7 @@ def test_data_source_signed(no_request_pub):
     data_source.data_source = {'type': 'json', 'value': "https://no-secret.example.com/json"}
     data_source.store()
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: StringIO('{"data": [{"id": 0, "text": "zero"}]}')
+        urlopen.side_effect = lambda *args: io.StringIO('{"data": [{"id": 0, "text": "zero"}]}')
         assert len(data_sources.get_items({'type': 'foobar'})) == 1
         unsigned_url = urlopen.call_args[0][0]
     assert unsigned_url == 'https://no-secret.example.com/json'
@@ -951,7 +951,7 @@ def test_named_datasource_json_cache(requests_pub):
     datasource.store()
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: StringIO(
+        urlopen.side_effect = lambda *args: io.StringIO(
             json.dumps({'data': [{'id': '1', 'text': 'foo'}, {'id': '2', 'text': 'bar'}]})
         )
 
@@ -997,7 +997,7 @@ def test_named_datasource_id_parameter(requests_pub):
 
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         value = [{'id': '1', 'text': 'foo'}]
-        urlopen.side_effect = lambda *args: StringIO(json.dumps({'data': value}))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps({'data': value}))
         assert datasource.get_structured_value('1') == value[0]
         assert urlopen.call_count == 1
         assert urlopen.call_args[0][0] == 'http://whatever/?id=1'
@@ -1009,27 +1009,27 @@ def test_named_datasource_id_parameter(requests_pub):
     get_request().datasources_cache = {}
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         value = [{'id': '1', 'text': 'bar'}, {'id': '2', 'text': 'foo'}]
-        urlopen.side_effect = lambda *args: StringIO(json.dumps({'data': value}))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps({'data': value}))
         assert datasource.get_structured_value('1') == value[0]
         assert urlopen.call_count == 1
 
     get_request().datasources_cache = {}
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: StringIO(json.dumps({'data': []}))  # empty list
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps({'data': []}))  # empty list
         assert datasource.get_structured_value('1') is None
         assert urlopen.call_count == 1
 
     get_request().datasources_cache = {}
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         value = [{'id': '1', 'text': 'foo'}]
-        urlopen.side_effect = lambda *args: StringIO(json.dumps({'data': value, 'err': 0}))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps({'data': value, 'err': 0}))
         assert datasource.get_structured_value('1') == value[0]
         assert urlopen.call_count == 1
 
     get_request().datasources_cache = {}
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         value = [{'id': '1', 'text': 'foo'}]
-        urlopen.side_effect = lambda *args: StringIO(json.dumps({'data': value, 'err': 1}))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps({'data': value, 'err': 1}))
         assert datasource.get_structured_value('1') is None
         assert urlopen.call_count == 1
         # no cache for errors
@@ -1039,13 +1039,13 @@ def test_named_datasource_id_parameter(requests_pub):
     get_request().datasources_cache = {}
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         value = {'id': '1', 'text': 'foo'}  # not a list
-        urlopen.side_effect = lambda *args: StringIO(json.dumps({'data': value}))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps({'data': value}))
         assert datasource.get_structured_value('1') is None
         assert urlopen.call_count == 1
 
     get_request().datasources_cache = {}
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
-        urlopen.side_effect = lambda *args: StringIO('not json')
+        urlopen.side_effect = lambda *args: io.StringIO('not json')
         assert datasource.get_structured_value('1') is None
         assert urlopen.call_count == 1
 
@@ -1053,7 +1053,7 @@ def test_named_datasource_id_parameter(requests_pub):
     get_request().datasources_cache = {}
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         value = [{'id': '1', 'text': 'bar'}, {'id': '2', 'text': 'foo'}]
-        urlopen.side_effect = lambda *args: StringIO(json.dumps({'data': value}))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps({'data': value}))
         assert datasource.get_structured_value('2') == value[1]
         assert urlopen.call_count == 1
         # try again, get from request.datasources_cache
@@ -1062,7 +1062,7 @@ def test_named_datasource_id_parameter(requests_pub):
     get_request().datasources_cache = {}
     with mock.patch('wcs.qommon.misc.urlopen') as urlopen:
         value = [{'id': '1', 'text': 'bar'}, {'id': '2', 'text': 'foo'}]
-        urlopen.side_effect = lambda *args: StringIO(json.dumps({'data': value}))
+        urlopen.side_effect = lambda *args: io.StringIO(json.dumps({'data': value}))
         assert datasource.get_structured_value('3') is None
         assert urlopen.call_count == 1
         # try again, get from request.datasources_cache
diff --git a/tests/test_datasource_chrono.py b/tests/test_datasource_chrono.py
index a89182aac..f882f4cb5 100644
--- a/tests/test_datasource_chrono.py
+++ b/tests/test_datasource_chrono.py
@@ -1,11 +1,10 @@
 # -*- coding: utf-8 -*-
 
+import io
 import pytest
 import json
 import shutil
 
-from django.utils.six import StringIO
-
 from quixote import cleanup
 from wcs import fields
 from wcs.data_sources import NamedDataSource, build_agenda_datasources, collect_agenda_data
@@ -112,7 +111,7 @@ def test_collect_agenda_data(urlopen, pub, chrono_url):
     pub.load_site_options()
     NamedDataSource.wipe()
 
-    urlopen.side_effect = lambda *args: StringIO('{"data": []}')
+    urlopen.side_effect = lambda *args: io.StringIO('{"data": []}')
     assert collect_agenda_data(pub) == []
     assert urlopen.call_args_list == [mock.call('http://chrono.example.net/api/agenda/')]
 
@@ -122,7 +121,7 @@ def test_collect_agenda_data(urlopen, pub, chrono_url):
     assert urlopen.call_args_list == [mock.call('http://chrono.example.net/api/agenda/')]
 
     # events agenda
-    urlopen.side_effect = lambda *args: StringIO(json.dumps({"data": AGENDA_EVENTS_DATA}))
+    urlopen.side_effect = lambda *args: io.StringIO(json.dumps({"data": AGENDA_EVENTS_DATA}))
     urlopen.reset_mock()
     assert collect_agenda_data(pub) == [
         {'text': 'Events A', 'url': 'http://chrono.example.net/api/agenda/events-A/datetimes/'},
@@ -132,9 +131,9 @@ def test_collect_agenda_data(urlopen, pub, chrono_url):
 
     # meetings agenda
     urlopen.side_effect = [
-        StringIO(json.dumps({"data": AGENDA_MEETINGS_DATA})),
-        StringIO(json.dumps({"data": AGENDA_MEETING_TYPES_DATA['meetings-A']})),
-        StringIO(json.dumps({"data": AGENDA_MEETING_TYPES_DATA['virtual-B']})),
+        io.StringIO(json.dumps({"data": AGENDA_MEETINGS_DATA})),
+        io.StringIO(json.dumps({"data": AGENDA_MEETING_TYPES_DATA['meetings-A']})),
+        io.StringIO(json.dumps({"data": AGENDA_MEETING_TYPES_DATA['virtual-B']})),
     ]
     urlopen.reset_mock()
     assert collect_agenda_data(pub) == [
@@ -164,8 +163,8 @@ def test_collect_agenda_data(urlopen, pub, chrono_url):
 
     # if meeting types could not be collected
     urlopen.side_effect = [
-        StringIO(json.dumps({"data": AGENDA_MEETINGS_DATA})),
-        StringIO(json.dumps({"data": AGENDA_MEETING_TYPES_DATA['meetings-A']})),
+        io.StringIO(json.dumps({"data": AGENDA_MEETINGS_DATA})),
+        io.StringIO(json.dumps({"data": AGENDA_MEETING_TYPES_DATA['meetings-A']})),
         ConnectionError,
     ]
     urlopen.reset_mock()
@@ -177,7 +176,7 @@ def test_collect_agenda_data(urlopen, pub, chrono_url):
     ]
 
     urlopen.side_effect = [
-        StringIO(json.dumps({"data": AGENDA_MEETINGS_DATA})),
+        io.StringIO(json.dumps({"data": AGENDA_MEETINGS_DATA})),
         ConnectionError,
     ]
     urlopen.reset_mock()
